/*
 
  ͻ                   
   OpenSource Library                    
  ͼ                   
   Author : Vitaly Checkryzhev             
   E-Mail : virty1k@mail.ru                
   WWW    : http://www.str.ru/~virty       
   WWW    : http://virtualsoft.narod.ru    
                                           
  VIRtUal Soft         All rights reserved 
 
  
*/


#include <stdio.h>
#include <iostream.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

int n;
float **A, **B, **C, **X, **Y;

void
inputMx (float **M)
{
 // Input matrix
 for (int i = 0; i < n; i++)
   {
    for (int j = 0; j < n; j++)
      {
       printf ("M[%d, %d] = ", i + 1, j + 1);
       cin >> M[i][j];
      }
   }
}

void
printMx (float **M)
{
 // Print matrix
 for (int i = 0; i < n; i++)
   {
    for (int j = 0; j < n; j++)
     printf ("%.05f ", M[i][j]);
    puts ("");
   }
}

void
LUdiff (float **M)
{
 for (int i = 0; i < n; i++)
  C[i][i] = 1;

 for (int i = 0; i < n; i++)
   {
    for (int j = 0; j < n; j++)
      {
       if (i < j)
	 {
	  float S = 0;
	  for (int k = 0; k < i; k++)
	   S += B[i][k] * C[k][j];
	  C[i][j] = (M[i][j] - S) / B[i][i];
	 }
       else
	 {
	  float S = 0;
	  for (int k = 0; k < j; k++)
	   S += B[i][k] * C[k][j];
	  B[i][j] = (M[i][j] - S) / C[j][j];
	 }
      }
   }
}

float
detMx (float **M)
{
 // Matrix determiner
 LUdiff (M);
 float dt = B[0][0];
 for (int i = 1; i < n; i++)
  dt *= B[i][i];
 return dt;
}

void
backMx ()
{
 // Back matrix
 float **Y = new float *[n];
 for (int i = 0; i < n; i++)
  Y[i] = new float [n];

 for (int j = 0; j < n; j++)
   {
    for (int i = 0; i < n; i++)
      {
       float S = 0;
       for (int k = 0; k < i; k++)
	S += B[i][k] * Y[k][j];
       Y[i][j] = (float (i == j) - S) / B[i][i];
      }
   }

 for (int j = 0; j < n; j++)
   {
    for (int i = n - 1; i > -1; i--)
      {
       float S = 0;
       for (int k = i + 1; k < n; k++)
	S += C[i][k] * X[k][j];
       X[i][j] = (Y[i][j] - S) / C[i][i];
      }
   }

 for (int i = 0; i < n; i++)
  delete (Y[i]);
 delete (Y);
}

char
equalMx (float **M1, float **M2)
{
 // Check for equivalence
 for (int i = 0; i < n; i++)
  for (int j = 0; j < n; j++)
   if (M1[i][j] != M2[i][j])
    return 0;
 return 1;
}

int
main ()
{
 cout << "Size of matrix: ";
 cin >> n;

 // Allocate memory
 A = new float *[n]; B = new float *[n];
 C = new float *[n]; X = new float *[n];
 Y = new float *[n];
 for (int i = 0; i < n; i++)
  {
   A[i] = new float [n]; B[i] = new float [n];
   C[i] = new float [n]; X[i] = new float [n];
   Y[i] = new float [n];
  }

 cout << "Enter input matrix A\n";
 inputMx (A);
 LUdiff (A);

 cout << "Matrix A");
 printMx (A);

 cout << "Matrix B");
 printMx (B);
 cout << "Matrix C");
 printMx (C);

 backMx ();

 // Calculating additive matrix A*
 float dt = detMx (A);
 for (int i = 0; i < n; i++)
  for (int j = 0; j < n; j++)
   Y[i][j] = X[i][j] * dt;

 dt = detMx (X);
 for (int i = 0; i < n; i++)
  for (int j = 0; j < n; j++)
    {
     // Calculate |A^-1| * (A*)
     B[i][j] = Y[i][j] * dt;

     // Round to 5 significant signes
     B[i][j] = roundf (B[i][j] * 100000) / 100000;
     X[i][j] = roundf (X[i][j] * 100000) / 100000;
    }

 cout <<"Matrix A^-1\n";
 printMx (X);

 cout << "Matrix (A*) * |A^-1|\n";
 printMx (B);

 // Compare matrices
 cout << (equalMx (B, X)) ? "Matrices are equal\n" : "Matrices differs\n";

 // Release memory
 for (int i = 0; i < n; i++)
  {
   delete (A[i]); delete (B[i]);
   delete (C[i]); delete (X[i]);
   delete (Y[i]);
  }

 delete (A); delete (B);
 delete (C); delete (X);
 delete (Y);
 return 0;
}
